package com.city.cdcmonitor.config;

import lombok.extern.slf4j.Slf4j;
import org.apache.ibatis.session.SqlSessionFactory;
import org.mybatis.spring.SqlSessionFactoryBean;
import org.mybatis.spring.SqlSessionTemplate;
import org.mybatis.spring.annotation.MapperScan;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.context.annotation.Profile;
import org.springframework.core.io.support.PathMatchingResourcePatternResolver;
import org.springframework.jdbc.datasource.DataSourceTransactionManager;

import javax.sql.DataSource;

@Configuration
@Slf4j
@MapperScan(basePackages = "com.city.cdcmonitor.dao.jkcloud.mapper", sqlSessionTemplateRef = "sqlSessionTemplateJkcloud")
public class DataSourceJkcloudConfig {

    @Profile("dev")
    @Bean(name = "dataSourceJkcloud")
    public DataSource dataSource() {
        log.info("jkcloud dev 环境==================>>>");
        CityHikariDataSource dataSource = new CityHikariDataSource();
        dataSource.setUser("middb");
        dataSource.setPassword("1qaz2wsx!");
        dataSource.setJdbcUrl("jdbc:sqlserver://120.55.160.15:1433;DataBase=MIDDB");
        return dataSource;
    }

    @Profile("prod")
    @Bean(name = "dataSourceJkcloud")
    public DataSource dataSourceProd() {
        log.info("jkcloud prod 环境============>>>");
        CityHikariDataSource dataSource = new CityHikariDataSource();
        dataSource.setUser("chengdi");
        dataSource.setPassword("1qaz2wsx!");
        dataSource.setJdbcUrl("jdbc:sqlserver://172.27.132.187:2433;DataBase=jkcloud");
        return dataSource;
    }

    @Bean(name = "sqlSessionFactoryJkcloud")
    public SqlSessionFactoryBean sqlSessionFactory(@Qualifier("dataSourceJkcloud") DataSource dataSource) throws Exception {
        SqlSessionFactoryBean bean = new SqlSessionFactoryBean();
        bean.setDataSource(dataSource);
        bean.setMapperLocations(new PathMatchingResourcePatternResolver().getResources("classpath:mapper/jkcloud/*.xml"));
        return bean;
    }

    @Bean(name = "sqlSessionTemplateJkcloud")
    public SqlSessionTemplate sqlSessionTemplate(@Qualifier("sqlSessionFactoryJkcloud") SqlSessionFactory sqlSessionFactory) {
        return new SqlSessionTemplate(sqlSessionFactory);
    }

    @Bean(name = "transactionManagerJkcloud")
    public DataSourceTransactionManager transactionManager(@Qualifier("dataSourceJkcloud") DataSource dataSource) {
        return new DataSourceTransactionManager(dataSource);
    }
}
