package com.city.cdcmonitor.config;

import lombok.extern.slf4j.Slf4j;
import org.apache.ibatis.session.SqlSessionFactory;
import org.mybatis.spring.SqlSessionFactoryBean;
import org.mybatis.spring.SqlSessionTemplate;
import org.mybatis.spring.annotation.MapperScan;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.context.annotation.Profile;
import org.springframework.core.io.support.PathMatchingResourcePatternResolver;
import org.springframework.jdbc.datasource.DataSourceTransactionManager;

import javax.sql.DataSource;

@Configuration
@Slf4j
@MapperScan(basePackages = "com.city.cdcmonitor.dao.middb.mapper", sqlSessionTemplateRef = "sqlSessionTemplateMiddb")
public class DataSourceMiddbConfig {

	@Profile("dev")
	@Bean(name = "dataSourceMiddb")
	public DataSource dataSource() {
		CityHikariDataSource dataSource = new CityHikariDataSource();
		dataSource.setUser("middb");
		dataSource.setPassword("1qaz2wsx!");
		dataSource.setJdbcUrl("jdbc:sqlserver://120.55.160.15:1433;DataBase=MIDDB");
		return dataSource;
	}

	@Profile("prod")
	@Bean(name = "dataSourceMiddb")
	public DataSource dataSourceProd() {
		CityHikariDataSource dataSource = new CityHikariDataSource();
		dataSource.setUser("middb");
		dataSource.setPassword("1qaz2wsx!");
		dataSource.setJdbcUrl("jdbc:sqlserver://195.1.20.27:2433;DataBase=MIDDB");
		return dataSource;
	}
	
	@Bean(name = "sqlSessionFactoryMiddb")
	public SqlSessionFactoryBean sqlSessionFactory(@Qualifier("dataSourceMiddb") DataSource dataSource) throws Exception {
		SqlSessionFactoryBean bean = new SqlSessionFactoryBean();
		bean.setDataSource(dataSource);
		bean.setMapperLocations(new PathMatchingResourcePatternResolver().getResources("classpath:mapper/middb/*.xml"));
		return bean;
	}

	@Bean(name = "sqlSessionTemplateMiddb")
	public SqlSessionTemplate sqlSessionTemplate(@Qualifier("sqlSessionFactoryMiddb") SqlSessionFactory sqlSessionFactory) {
		return new SqlSessionTemplate(sqlSessionFactory);
	}

	@Bean(name = "transactionManagerMiddb")
	public DataSourceTransactionManager transactionManager(@Qualifier("dataSourceMiddb") DataSource dataSource) {
		return new DataSourceTransactionManager(dataSource);
	}
}
