package com.city.cdcmonitor.fegin;

import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.Map;

/**
 * 这是一个测试feign是否有校的方法
 * 萤石api获取accessToken, FeignClient调用固定url接口
 */
@FeignClient(name = "access-token", url = "https://open.ys7.com")
public interface TokenFeign {

    /**
     * 根据appKey和secret获取accessToken, appKey和secret可以在官网-开发者服务-我的应用中找到
     * 获取到的accessToken有效期是7天，请在即将过期或者接口报错10002时重新获取，每个token具备独立的7天生命周期，请勿频繁调用避免占用过多接口调用次数。
     */
    @PostMapping("/api/lapp/token/get")
    Map<String, Object> getAccessToken(@RequestParam String appKey, @RequestParam String appSecret,
                                       @RequestHeader(name = "Token", required = false) String Token);

}
