package com.city.cdcmonitor.task;

import com.city.cdcmonitor.service.CdcStatisticsService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.scheduling.annotation.Async;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;

/**
 * 接口心跳
 */
@Slf4j
@Component
@ConditionalOnProperty(prefix = "task", name = "heartbeat", havingValue = "true")
public class Heartbeat {
    @Resource
    private CdcStatisticsService cdcStatisticsService;

    @Scheduled(cron = "0/30 * * * * ?")
    public void task(){
        try {
//            cdcStatisticsService.interfaceHeartbeat(null, null);
        } catch (Exception e) {
            log.error(" ### [接口心跳],执行异常： ", e);
        }
    }
}
