package com.city.cdcmonitor.utils;

import com.alibaba.excel.annotation.ExcelProperty;
import com.city.cdcmonitor.bean.ExportColumnBean;

import java.lang.reflect.Field;
import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;

public class EntityUtils {

    public static List<ExportColumnBean> getExportColumnList(Class<?> clazz) {
        List<ExportColumnBean> list = new ArrayList<>();
        Field[] fields = clazz.getDeclaredFields();
        for (Field field : fields) {
            if (field.isAnnotationPresent(ExcelProperty.class)) {
                //字段
                String name = field.getName();
                ExcelProperty declaredAnnotation = field.getDeclaredAnnotation(ExcelProperty.class);
                //@ExcelProperty属性
                String desc = declaredAnnotation.value()[0];
                ExportColumnBean bean = new ExportColumnBean(name, desc);
                list.add(bean);
            }
        }
        return list;
    }

    public static List<ExportColumnBean> getExportColumnList(LinkedHashMap<String, Object> data) {
        List<ExportColumnBean> list = new ArrayList<>();

        for (String key : data.keySet()) {
            ExportColumnBean bean = new ExportColumnBean(key, key);
            list.add(bean);
        }

        return list;
    }

    public static List<ExportColumnBean> getExportColumnList4() {
        List<ExportColumnBean> list = new ArrayList<>();
        list.add(new ExportColumnBean("插入_更新_删除总量"));
        list.add(new ExportColumnBean("日志_Select数量"));
        list.add(new ExportColumnBean("日志_Insert数量"));
        list.add(new ExportColumnBean("表当日实际Insert数量"));
        list.add(new ExportColumnBean("日志_Update数量"));
        list.add(new ExportColumnBean("表当日实际update数量"));
        list.add(new ExportColumnBean("日志_Delete数量"));
        list.add(new ExportColumnBean("表当日实际Delete数量"));
        list.add(new ExportColumnBean("插入失败"));
        list.add(new ExportColumnBean("更新失败"));
        list.add(new ExportColumnBean("删除失败"));
        list.add(new ExportColumnBean("操作时间"));
        list.add(new ExportColumnBean("操作表"));
        list.add(new ExportColumnBean("inx"));
        return list;
    }

    public static List<ExportColumnBean> getExportColumnList5() {
        List<ExportColumnBean> list = new ArrayList<>();
        list.add(new ExportColumnBean("日志_Select数量"));
        list.add(new ExportColumnBean("日志_Insert数量"));
        list.add(new ExportColumnBean("表当日实际Insert数量"));
        list.add(new ExportColumnBean("日志_Update数量"));
        list.add(new ExportColumnBean("表当日实际update数量"));
        list.add(new ExportColumnBean("日志_Delete数量"));
        list.add(new ExportColumnBean("表当日实际Delete数量"));
        list.add(new ExportColumnBean("插入失败"));
        list.add(new ExportColumnBean("更新失败"));
        list.add(new ExportColumnBean("删除失败"));
        list.add(new ExportColumnBean("操作时间"));
        list.add(new ExportColumnBean("操作表"));
        list.add(new ExportColumnBean("inx"));
        list.add(new ExportColumnBean("插入_更新_删除总量"));
        list.add(new ExportColumnBean("jkcloud实际入库数量"));
        list.add(new ExportColumnBean("数量对比差值"));
        return list;
    }
}
