package com.city.cdcmonitor.utils;

import java.math.BigDecimal;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Collection;
import java.util.List;
import java.util.Map;
import java.util.regex.Pattern;


public class ValidateUtils {
    public static boolean isEmpty(Collection collection) {
        return collection == null || collection.isEmpty();
    }

    public static boolean isNotEmpty(Collection collection) {
        return !isEmpty(collection);
    }

    public static boolean isEmpty(Map map) {
        return map == null || map.isEmpty();
    }

    public static boolean isNotEmpty(Map map) {
        return !isEmpty(map);
    }

    public static boolean isEmpty(List list) {
        return list == null || list.isEmpty();
    }

    public static boolean isNotEmpty(List list) {
        return !isEmpty(list);
    }

    public static boolean isEmpty(String string) {
        return ((string == null) || (string.trim().length() == 0));
    }

    public static boolean isNotEmpty(String string) {
        return !isEmpty(string);
    }

    public static <T> boolean isEmpty(T[] array) {
        return array == null || array.length == 0;
    }

    public static <T> boolean isNotEmpty(T[] array) {
        return array != null && array.length != 0;
    }

    public static boolean isDouble(Object object) {
        if (object == null) return false;
        try {
            Double.parseDouble(String.valueOf(object));
        } catch (NumberFormatException e) {
            e.printStackTrace();
            return false;
        }
        return true;
    }

    public static boolean isNotDouble(Object object) {
        return !isDouble(object);
    }

    public static boolean isInteger(Object object) {
        if (object == null) return false;
        try {
            Integer.parseInt(String.valueOf(object));
        } catch (NumberFormatException e) {
            e.printStackTrace();
            return false;
        }
        return true;
    }

    public static boolean isNotInteger(Object object) {
        return !isInteger(object);
    }

    public static boolean isLong(Object object) {
        if (object == null) return false;
        try {
            Long.parseLong(String.valueOf(object));
        } catch (NumberFormatException e) {
            e.printStackTrace();
            return false;
        }
        return true;
    }

    public static boolean isNotLong(Object object) {
        return !isLong(object);
    }

    public static boolean isBigDecimal(Object object) {
        if (object == null) return false;
        try {
            BigDecimal bigDecimal = new BigDecimal(String.valueOf(object));
            return true;
        } catch (Exception e) {
            e.printStackTrace();
            return false;
        }
    }

    public static boolean isNotBigDecimal(Object object) {
        return !isBigDecimal(object);
    }

    public static boolean isDate(String date) {
        if (isEmpty(date)) return false;
        String pattern;
        if (date.length() == DateUtils.DATE_PATTERN1.length()) {
            pattern = DateUtils.DATE_PATTERN1;
        } else if (date.length() == DateUtils.DATE_PATTERN2.length()) {
            pattern = DateUtils.DATE_PATTERN2;
        } else if (date.length() == DateUtils.DATE_PATTERN3.length()) {
            pattern = DateUtils.DATE_PATTERN3;
        } else if (date.length() == DateUtils.DATE_PATTERN4.length()) {
            pattern = DateUtils.DATE_PATTERN4;
        } else if (date.length() == DateUtils.DATE_PATTERN5.length()) {
            pattern = DateUtils.DATE_PATTERN5;
        } else if (date.length() == DateUtils.DATE_PATTERN6.length()) {
            pattern = DateUtils.DATE_PATTERN6;
        } else if (date.length() == DateUtils.DATE_PATTERN7.length()) {
            pattern = DateUtils.DATE_PATTERN7;
        } else if (date.length() == DateUtils.DATE_PATTERN8.length()) {
            pattern = DateUtils.DATE_PATTERN8;
        } else {
            return false;
        }
        try {
            SimpleDateFormat sdf = new SimpleDateFormat(pattern);
            sdf.parse(date);
        } catch (ParseException e) {
            e.printStackTrace();
            return false;
        }
        return true;
    }

    public static boolean isNotDate(String date) {
        return !isDate(date);
    }

    public static boolean isMobile(String mobile) {
        Pattern p = Pattern.compile("^(1)\\d{10}$");
        return p.matcher(mobile).matches();
    }

    public static boolean isNotMobile(String mobile) {
        return !isMobile(mobile);
    }

    public static boolean isEmail(String email) {
        if (isEmpty(email) || email.length() > 60) {
            return false;
        }
        String regex = "\\w+([-+.]\\w+)*@\\w+([-.]\\w+)*\\.\\w+([-.]\\w+)*";
        Pattern p = Pattern.compile(regex);
        return p.matcher(email).matches();
    }

    public static boolean isNotEmail(String email) {
        return !isEmail(email);
    }
}
